package VS;

import java.util.*;
// vsObservableDouble - a double Observable
//
// This class implements the Observable mechanism for
// a simple double variable.
// You can set the value with setValue(double)
// and double getValue() returns the current value.
public class vsObservableDouble extends Observable
{
     double value;     // The value everyone wants to observe
     public vsObservableDouble()
     {
          value = 0;     // By default, let value be 0
     }
     public vsObservableDouble(double newValue)
     {
          value = newValue;     // Allow value to be set when created
     }
     public synchronized void setValue(double newValue)
     {
//
// Check to see that this call is REALLY changing the value
//
          if (newValue != value)
          {
               value = newValue;
               setChanged();     // Mark this class as "changed"
               notifyObservers();     // Tell the observers about it
          }
     }
     public synchronized double getValue()
     {
          return value;
     }
}