package ipl;
import java.io.*;
import java.net.*;
import java.awt.*;
import java.util.*;
import java.lang.Math;

public  class Dijkstra {

  private static int index[];
  private static int matrix[][];
  private static int segs[][];
  private static int segs1[];
  private static int numCities = 0;
  private static int path[];
  private static boolean inSet[];
  private static int distTo[];
  private static URL fileURL;
  private static int nodes;
  private static DataOutputStream dos;
  private static FileInputStream fis ;



  public static void main( String args[] ) {
     matrix = new int[1000][1000];
     index = new int[1000];
     path = new int[1000];
     inSet = new boolean[1000];
     distTo = new int[1000];
     segs=new int[1000][4];
     segs1=new int[1000];
     nodes =100;

     init();
     readFile();
  //   FindPaths();
     reorderVectors(0);
     writeFile();

  }



  public static void findPaths() {
    int i, j, k;

    for (k=0;k<numCities;++k)
        {
        for (i=0;i<numCities;++i)
           for (j=i+1;j<numCities;++j)
                if ((matrix[i][k]+matrix[k][j])<matrix[i][j])
                {
                  matrix[i][j]=matrix[i][k]+matrix[k][j];
                  matrix[j][i]=matrix[i][j];
                }
        System.out.println(nodes-k+" steps left");
        }

  }

/*
  public static void ReorderVectors(int start)
  {
    int i, j, k,l,m;

    k=0x7FFFFFFF;
    m=nodes;
    index[nodes-m]=start;
    l=start;
      while (m>0){
        for (i=0;i<numCities;++i)
           if ((matrix[start][i]<k) && (start!=i)&&(matrix[start][i]>=0)) {
             k=matrix[start][i];
             l=i;
           }
        for (i=0;i<numCities;++i)
             matrix[i][l]=-1;
        k=0x7FFFFFFF;
        m=m-1;
        start=l;
        index[nodes-m]=l;
     }
  }


*/

  public static void reorderVectors(int start)
  {
    int i, j, k,l,m,n;

    k=0x7FFFFFFF;
    n=k;
    m=nodes;
    index[nodes-m]=start;
    l=start;
      while (m>0){
        for (i=0;i<numCities;++i){
           if ((start!=i)&&(segs1[i]>=0))
                 {
                 n=computeDistance1(segs[start][2],segs[start][3],i);
                 if (n<k){
                     k=n;
                     l=i;
                         }
                 }
           }
        segs1[l]=-1;
        k=0x7FFFFFFF;
        m=m-1;
        start=l;
        index[nodes-m]=l;
     }
  }


  public static String getPath( int start, int dest ) {
     String s;
     int i;

     s = "";
     i = dest;
     while( path[ i ] != -1 )
     {
       s = " -> " + index[i] + "(" + matrix[path[i]][i] + ")" + s;
       i = path[i];
     }
     s = index[start] + s;
     return s;
  }


  public static void init()  {
    for( int i = 0; i < 1000; ++i )
    {
      for( int j = 0; j < 1000; ++j )
        matrix[i][j] = 0;
      path[i] = 0;
      segs1[i]=0;
      inSet[i] = false;
      distTo[i] = 0;
    }
  }


   public static String getReadFileName(int option) {
    		String s;
            s=null;
            if (option==1) s="Opening file: ";
   	     	else   	s="Saving file: ";
   	     	FileDialog dialog = 
   	     		new FileDialog(new Frame(), "file select",option-1);
      		dialog.show();
      		String file_name = dialog.getFile();
      		String path_name = dialog.getDirectory();
      		String file_string = path_name + file_name;
      		System.out.println(s+file_string+"...");
      		dialog.dispose();
      		return file_string;
   }


  public static void readFile()  {
     int i, j, dist;
     String s;

     nodes=0;
            try{
			    fis = new FileInputStream(getReadFileName(1));
    		}
    		catch(Exception e){ }
  			StreamTokenizer tk=new  StreamTokenizer(fis);
			try{
				while(tk.nextToken()!=tk.TT_EOF){
   				    segs[nodes][0] =(int)tk.nval;
					tk.nextToken();
					segs[nodes][1]=(int)tk.nval;
					tk.nextToken();
					segs[nodes][2]=(int)tk.nval;
					tk.nextToken();
					segs[nodes][3]=(int)tk.nval;
                    index[nodes] =nodes;
                    nodes++;
    				}
	    		}
			catch(Exception e){ }
			try{
				fis.close();
			}
			catch(Exception e){}


     numCities=nodes-1;
     for (i=0;i<nodes;i++)
       for (j=0;j<nodes;j++)
       if (i!=j)
         matrix[i][j]=computeDistance(i,j);
 }

public static int computeDistance(int i, int j){
int d1, xmid1, ymid1, xmid2, ymid2;

xmid1=(segs[i][2]-segs[i][0]);
ymid1=(segs[i][3]-segs[i][1]);
xmid2=(segs[j][2]-segs[j][0]);
ymid2=(segs[j][3]-segs[j][1]);
d1=(xmid2-xmid1)*(xmid2-xmid1)+(ymid2-ymid1)*(ymid2-ymid1);
d1=d1/4;
d1=(int)Math.sqrt(d1);
return d1;

}

public static int computeDistance1(int i, int j,int k){
int d1, xmid1, ymid1, xmid2, ymid2;

xmid1=(int)Math.sqrt(
	(segs[k][0]-i)*(segs[k][0]-i)+(segs[k][1]-j)*(segs[k][1]-j));
xmid2=(int)Math.sqrt(
	(segs[k][2]-i)*(segs[k][2]-i)+(segs[k][3]-j)*(segs[k][3]-j));
d1=xmid1+xmid2;
return d1;

}


  public static void writeFile() {
     String s = " ";
     String d = null;
     int i, j, dist;

       try{
        dos = new 
        	DataOutputStream(new FileOutputStream(getReadFileName(2)) );
          }
       catch (IOException e) {
        System.err.println("File not opened properly\n"+e.toString());
        System.exit(1);
       }

       try{
        for(i=0;i<nodes;++i)
         {
         j=index[i];
         System.out.println(String.valueOf(i)+" - Segments left");
         d=null;
         d=String.valueOf(segs[j][0]);
         while (d.length()<10) d=" "+d;
         dos.writeBytes(d);
         d=null;
         d=String.valueOf(segs[j][1]);
         while (d.length()<10) d=" "+d;
         dos.writeBytes(d);
         d=null;
         d=String.valueOf(segs[j][2]);
         while (d.length()<10) d=" "+d;
         dos.writeBytes(d);
         d=null;
         d=String.valueOf(segs[j][3]);
         while (d.length()<10) d=" "+d;
         dos.writeBytes(d+"\r\n");
         }
       }
       catch (IOException e) {
            System.err.println("File not opened properly\n"+e.toString());
            System.exit(1);
         }

       try{
       	dos.flush();
       	dos.close();
       }
       catch (IOException e) {
          System.err.println("File not opened properly\n"+e.toString());
          System.exit(1);
       }
  }

}

